(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 7.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[     61482,       1538]
NotebookOptionsPosition[     59976,       1491]
NotebookOutlinePosition[     60322,       1506]
CellTagsIndexPosition[     60279,       1503]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[TextData[StyleBox["Usage examples for Plenum <--> Cambium conversion.  \n\
\nAuthors: Darren Davis (translator code), Guy Yosiphon (grammar examples), \
Scientific Inference Systems Laboratory, UC Irvine",
 FontSize->14]], "Text",
 CellChangeTimes->{{3.4601369649309998`*^9, 3.4601371225690002`*^9}, {
  3.460137192552*^9, 3.46013736488*^9}, {3.4602328925863633`*^9, 
  3.4602328945673633`*^9}, {3.4921814938008575`*^9, 3.4921815305059566`*^9}, {
  3.492190244167014*^9, 3.4921902698374825`*^9}, {3.4921903841730223`*^9, 
  3.492190400989984*^9}, {3.4921905051909437`*^9, 3.4921905102452335`*^9}, {
  3.4921908389180317`*^9, 3.492190840317112*^9}, {3.4921909871495104`*^9, 
  3.492191018573308*^9}, {3.49219109518969*^9, 3.492191176541343*^9}, {
  3.4921973992462616`*^9, 3.492197406357668*^9}, {3.4921980259221053`*^9, 
  3.492198027070171*^9}},
 Background->GrayLevel[0.85]],

Cell[BoxData[
 RowBox[{
  RowBox[{"Get", "[", 
   RowBox[{
    RowBox[{"NotebookDirectory", "[", "]"}], " ", "<>", " ", 
    "\"\<CambiumPlenumTranslator.m\>\""}], "]"}], ";"}]], "Input",
 CellChangeTimes->{{3.492189586762413*^9, 3.492189602414308*^9}, {
  3.492191820359167*^9, 3.4921918229503155`*^9}}],

Cell[CellGroupData[{

Cell[TextData[StyleBox["Translation for an example grammar from Guy \
Yosiphon's demo.nb in the Plenum download \
(http://computableplant.ics.uci.edu/~guy/Plenum.html).  ",
 FontSize->14,
 FontWeight->"Bold"]], "Text",
 CellFrame->{{0, 0}, {0, 2}},
 CellGroupingRules->{GroupTogetherGrouping, 10001.},
 CellChangeTimes->{{3.4921905504425325`*^9, 3.4921906673092165`*^9}, 
   3.4921907164330263`*^9, 3.4921972543929763`*^9}],

Cell[BoxData[
 RowBox[{"exampleGrammar", " ", "=", " ", 
  RowBox[{"Grammar", "[", 
   RowBox[{"rules", "\[Rule]", "\[IndentingNewLine]", 
    RowBox[{"{", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{"cell", "[", 
        RowBox[{"id", ",", "r"}], "]"}], "\[Rule]", " ", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"cell", "[", 
          RowBox[{
           RowBox[{"grammarCreateObjectID", "[", "1", "]"}], ",", 
           RowBox[{"r", "/", "2"}]}], "]"}], ",", 
         RowBox[{"cell", "[", 
          RowBox[{
           RowBox[{"grammarCreateObjectID", "[", "2", "]"}], ",", 
           RowBox[{"r", "/", "2"}]}], "]"}]}], "}"}]}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"with", "[", 
       RowBox[{"k", "*", "r"}], "]"}], ",", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"cell", "[", 
        RowBox[{"id", ",", "r"}], "]"}], "\[Rule]", " ", 
       RowBox[{"{", "}"}]}], ",", "\[IndentingNewLine]", 
      RowBox[{"with", "[", "d", "]"}], ",", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"cell", "[", 
        RowBox[{"id", ",", "r"}], "]"}], "\[Rule]", " ", 
       RowBox[{"cell", "[", 
        RowBox[{"id", ",", "r"}], "]"}]}], ",", "\[IndentingNewLine]", 
      RowBox[{"solving", "[", 
       RowBox[{
        RowBox[{"r", "'"}], "\[Equal]", " ", 
        RowBox[{"m", " ", "r"}]}], "]"}]}], "\[IndentingNewLine]", "}"}]}], 
   "]"}]}]], "Input",
 CellFrame->{{0, 0}, {0, 0.5}},
 CellGroupingRules->{GroupTogetherGrouping, 10001.},
 CellChangeTimes->{{3.4921896929604874`*^9, 3.4921897162218175`*^9}, {
   3.492190545520251*^9, 3.4921905483334117`*^9}, {3.492190659184752*^9, 
   3.4921906608398466`*^9}, 3.4921907164330263`*^9, 3.4921971958496275`*^9, 
   3.4921972543929763`*^9}],

Cell[BoxData[
 RowBox[{"Grammar", "[", 
  RowBox[{"rules", "\[Rule]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"cell", "[", 
       RowBox[{"id", ",", "r"}], "]"}], "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"cell", "[", 
         RowBox[{
          RowBox[{"grammarCreateObjectID", "[", "1", "]"}], ",", 
          FractionBox["r", "2"]}], "]"}], ",", 
        RowBox[{"cell", "[", 
         RowBox[{
          RowBox[{"grammarCreateObjectID", "[", "2", "]"}], ",", 
          FractionBox["r", "2"]}], "]"}]}], "}"}]}], ",", 
     RowBox[{"with", "[", 
      RowBox[{"k", " ", "r"}], "]"}], ",", 
     RowBox[{
      RowBox[{"cell", "[", 
       RowBox[{"id", ",", "r"}], "]"}], "\[Rule]", 
      RowBox[{"{", "}"}]}], ",", 
     RowBox[{"with", "[", "d", "]"}], ",", 
     RowBox[{
      RowBox[{"cell", "[", 
       RowBox[{"id", ",", "r"}], "]"}], "\[Rule]", 
      RowBox[{"cell", "[", 
       RowBox[{"id", ",", "r"}], "]"}]}], ",", 
     RowBox[{"solving", "[", 
      RowBox[{
       SuperscriptBox["r", "\[Prime]",
        MultilineFunction->None], "\[Equal]", 
       RowBox[{"m", " ", "r"}]}], "]"}]}], "}"}]}], "]"}]], "Output",
 CellGroupingRules->{GroupTogetherGrouping, 10001.},
 CellChangeTimes->{
  3.4921972059182034`*^9, {3.4921972543929763`*^9, 3.4921972571101313`*^9}, 
   3.4921980586049747`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"cambiumVersion", " ", "=", " ", 
  RowBox[{"exampleGrammar", " ", "//.", " ", "TranslateP2C"}]}]], "Input",
 CellFrame->{{0, 0}, {0, 0.5}},
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 CellChangeTimes->{{3.4921897335408077`*^9, 3.4921897418142815`*^9}, {
   3.4921898400529003`*^9, 3.492189842574044*^9}, 3.4921907164330263`*^9}],

Cell[BoxData[
 RowBox[{"CambiumArrow", "[", 
  RowBox[{
   RowBox[{"DynGram", "[", "composite", "]"}], ",", 
   RowBox[{"{", "}"}], ",", 
   RowBox[{"{", "}"}], ",", 
   RowBox[{"{", "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"GrammarParameters", "[", "]"}], ",", 
     RowBox[{"Rules", "[", 
      RowBox[{
       RowBox[{"CambiumArrow", "[", 
        RowBox[{
         RowBox[{"DynGram", "[", 
          RowBox[{"discrete", ",", "rule"}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"cell", "[", 
           RowBox[{"id", ",", "r"}], "]"}], "}"}], ",", 
         RowBox[{"{", "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"cell", "[", 
            RowBox[{
             RowBox[{"grammarCreateObjectID", "[", "1", "]"}], ",", 
             FractionBox["r", "2"]}], "]"}], ",", 
           RowBox[{"cell", "[", 
            RowBox[{
             RowBox[{"grammarCreateObjectID", "[", "2", "]"}], ",", 
             FractionBox["r", "2"]}], "]"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"with", "[", 
           RowBox[{"k", " ", "r"}], "]"}], "}"}]}], "]"}], ",", 
       RowBox[{"CambiumArrow", "[", 
        RowBox[{
         RowBox[{"DynGram", "[", 
          RowBox[{"discrete", ",", "rule"}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"cell", "[", 
           RowBox[{"id", ",", "r"}], "]"}], "}"}], ",", 
         RowBox[{"{", "}"}], ",", 
         RowBox[{"{", "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"with", "[", "d", "]"}], "}"}]}], "]"}], ",", 
       RowBox[{"CambiumArrow", "[", 
        RowBox[{
         RowBox[{"DynGram", "[", 
          RowBox[{"continuous", ",", "rule"}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"cell", "[", 
           RowBox[{"id", ",", "r"}], "]"}], "}"}], ",", 
         RowBox[{"{", "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"cell", "[", 
           RowBox[{"id", ",", "r"}], "]"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"solving", "[", 
           RowBox[{
            SuperscriptBox["r", "\[Prime]",
             MultilineFunction->None], "\[Equal]", 
            RowBox[{"m", " ", "r"}]}], "]"}], "}"}]}], "]"}]}], "]"}]}], 
    "}"}]}], "]"}]], "Output",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 CellChangeTimes->{
  3.492189742172302*^9, {3.4921898344085774`*^9, 3.492189842896063*^9}, 
   3.4921901524527683`*^9, 3.4921901900649195`*^9, 3.4921907164330263`*^9, 
   3.4921972059402046`*^9, 3.4921980586189756`*^9}],

Cell[BoxData[
 RowBox[{"cambiumVersion", " ", "//.", " ", "TranslateC2P"}]], "Input",
 CellFrame->{{0, 0}, {0, 0.5}},
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 CellChangeTimes->{{3.492189848369376*^9, 3.4921898537976866`*^9}, 
   3.4921907164330263`*^9}],

Cell[BoxData[
 RowBox[{"Grammar", "[", 
  RowBox[{"rules", "\[Rule]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"cell", "[", 
       RowBox[{"id", ",", "r"}], "]"}], "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"cell", "[", 
         RowBox[{
          RowBox[{"grammarCreateObjectID", "[", "1", "]"}], ",", 
          FractionBox["r", "2"]}], "]"}], ",", 
        RowBox[{"cell", "[", 
         RowBox[{
          RowBox[{"grammarCreateObjectID", "[", "2", "]"}], ",", 
          FractionBox["r", "2"]}], "]"}]}], "}"}]}], ",", 
     RowBox[{"with", "[", 
      RowBox[{"k", " ", "r"}], "]"}], ",", 
     RowBox[{
      RowBox[{"cell", "[", 
       RowBox[{"id", ",", "r"}], "]"}], "\[Rule]", 
      RowBox[{"{", "}"}]}], ",", 
     RowBox[{"with", "[", "d", "]"}], ",", 
     RowBox[{
      RowBox[{"cell", "[", 
       RowBox[{"id", ",", "r"}], "]"}], "\[Rule]", 
      RowBox[{"cell", "[", 
       RowBox[{"id", ",", "r"}], "]"}]}], ",", 
     RowBox[{"solving", "[", 
      RowBox[{
       SuperscriptBox["r", "\[Prime]",
        MultilineFunction->None], "\[Equal]", 
       RowBox[{"m", " ", "r"}]}], "]"}]}], "}"}]}], "]"}]], "Output",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 CellChangeTimes->{3.4921898542017097`*^9, 3.4921901924980593`*^9, 
  3.4921907164330263`*^9, 3.492197205959206*^9, 3.4921980586309757`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[StyleBox["Translation for an example grammar, with diffusion, \
from Guy Yosiphon's demo.nb in the Plenum download \
(http://computableplant.ics.uci.edu/~guy/Plenum.html).  \nThe auxiliary \
functions from demo.nb will be needed to execute this grammar in Plenum.",
 FontSize->14,
 FontWeight->"Bold"]], "Text",
 CellFrame->{{0, 0}, {0, 2}},
 CellGroupingRules->{GroupTogetherGrouping, 10001.},
 CellChangeTimes->{{3.4921905504425325`*^9, 3.4921906673092165`*^9}, 
   3.4921907164330263`*^9, {3.492190746864767*^9, 3.492190832678675*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"gCells2DDiffusion", " ", ":=", " ", 
   RowBox[{"Grammar", "[", 
    RowBox[{
     RowBox[{"spatialGrammar", "\[Rule]", " ", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"spatialObject", "\[Rule]", " ", "cell"}], ",", 
        RowBox[{"spatialObjCoordParamters", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"2", ",", " ", "3"}], "}"}]}], ",", 
        RowBox[{"spatialObjRadParam", "\[Rule]", " ", "4"}], ",", 
        RowBox[{"spatialObjDistance", "\[Rule]", " ", "gCellsDistance"}], ",", 
        RowBox[{
        "spatialBoundaryDistance", "\[Rule]", " ", "gCellPlaneDistance"}], 
        ",", 
        RowBox[{"spatialBottomBoundary", "\[Rule]", "bottomBoundary"}], ",", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{"spatialTopBoundary", "\[Rule]", "topBoundary"}], ","}], 
         "*)"}], 
        RowBox[{"spatialLeftBoundary", "\[Rule]", " ", "leftBoundary"}], ",", 
        RowBox[{"spatialRightBoundary", "\[Rule]", " ", "rightBoundary"}]}], 
       " ", "}"}]}], ",", 
     RowBox[{"gDiffusion", "\[Rule]", " ", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"gDiffVariable", "\[Rule]", " ", 
         RowBox[{"{", "prot1", "}"}]}], ",", "\[IndentingNewLine]", 
        RowBox[{"gDiffSpatialParamX", "\[Rule]", " ", 
         RowBox[{"{", 
          RowBox[{"{", 
           RowBox[{"cell", 
            RowBox[{"(*", "object", "*)"}], ",", "2"}], 
           RowBox[{"(*", 
            RowBox[{"parameter", " ", "position"}], "*)"}], "}"}], "}"}]}], 
        ",", 
        RowBox[{"gDiffSpatialParamY", "\[Rule]", " ", 
         RowBox[{"{", 
          RowBox[{"{", 
           RowBox[{"cell", 
            RowBox[{"(*", "object", "*)"}], ",", "3"}], 
           RowBox[{"(*", 
            RowBox[{"parameter", " ", "position"}], "*)"}], "}"}], "}"}]}], 
        ",", "\[IndentingNewLine]", 
        RowBox[{"gDiffSpatialParamR", "\[Rule]", " ", 
         RowBox[{"{", 
          RowBox[{"{", 
           RowBox[{"cell", 
            RowBox[{"(*", "object", "*)"}], ",", "4"}], 
           RowBox[{"(*", 
            RowBox[{"parameter", " ", "position"}], "*)"}], "}"}], "}"}]}], 
        ",", "\[IndentingNewLine]", 
        RowBox[{"gDiffDecay", "\[Rule]", " ", 
         RowBox[{"{", "gProt1Decay", "}"}]}], ",", 
        RowBox[{"gDiffConstant", "\[Rule]", " ", 
         RowBox[{"{", "gProt1Diff", "}"}]}], ",", 
        RowBox[{"gDiffSource", "\[Rule]", " ", 
         RowBox[{"{", "src1", "}"}]}], ",", "\[IndentingNewLine]", 
        RowBox[{"gDiffBoundaryTypeLeft", "\[Rule]", " ", "gPDETypeNeumann"}], 
        ",", "\[IndentingNewLine]", 
        RowBox[{"gDiffBoundaryTypeRight", "\[Rule]", " ", "gPDETypeNeumann"}],
         ",", "\[IndentingNewLine]", 
        RowBox[{
        "gDiffBoundaryTypeBottom", "\[Rule]", " ", "gPDETypeDirichlet"}], 
        RowBox[{"(*", "gPDETypeDirichlet", "*)"}], ",", "\[IndentingNewLine]", 
        RowBox[{"gDiffBoundaryTypeTop", "\[Rule]", " ", "gPDETypeNeumann"}], 
        ",", "\[IndentingNewLine]", 
        RowBox[{"gDiffBoundaryValLeft", "\[Rule]", " ", "0"}], ",", " ", 
        RowBox[{"gDiffBoundaryValRight", "\[Rule]", " ", "0"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"gDiffBoundaryValBottom", "\[Rule]", " ", "0"}], ",", 
        RowBox[{"gDiffBoundaryValTop", "\[Rule]", " ", "0"}]}], 
       "\[IndentingNewLine]", "}"}]}], ",", "\[IndentingNewLine]", 
     RowBox[{"rules", "\[Rule]", "\[IndentingNewLine]", 
      RowBox[{"{", "\[IndentingNewLine]", 
       RowBox[{"(*", " ", 
        RowBox[{
         RowBox[{"-", " ", "cell"}], " ", "growth"}], "*)"}], 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"{", 
          RowBox[{"cl", " ", "\[Equal]", " ", 
           RowBox[{"cell", "[", 
            RowBox[{
            "curCellID", ",", "curPosx", ",", "curPosy", ",", "curRad", ",", 
             "p1"}], "]"}]}], "}"}], "\[Rule]", " ", "cl"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"solving", "[", 
         RowBox[{
          SuperscriptBox["curRad", "\[Prime]",
           MultilineFunction->None], "\[Equal]", 
          RowBox[{"radFunction", "[", "curRad", "]"}]}], "]"}], ",", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{"LJ", "-", "potentials"}], " ", "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{"neighbor", " ", "cells", " ", "spring"}], "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"c1", "\[Equal]", " ", 
            RowBox[{"cell", "[", 
             RowBox[{
             "curCellID1", ",", "curPosx1", ",", "curPosy1", ",", "curRad1", 
              ",", "p11"}], "]"}]}], ",", 
           RowBox[{"c2", "\[Equal]", " ", 
            RowBox[{"cell", "[", 
             RowBox[{
             "curCellID2", ",", "curPosx2", ",", "curPosy2", ",", "curRad2", 
              ",", "p12"}], "]"}]}]}], "}"}], "\[Rule]", " ", 
         RowBox[{"{", 
          RowBox[{"c1", ",", "c2"}], "}"}]}], ",", "\[IndentingNewLine]", 
        RowBox[{"solving", "[", 
         RowBox[{
          RowBox[{
           SuperscriptBox["curPosx1", "\[Prime]",
            MultilineFunction->None], "\[Equal]", " ", 
           RowBox[{"ebXFunc", "[", 
            RowBox[{
            "curPosx1", ",", "curPosy1", ",", "curRad1", ",", "curPosx2", ",",
              "curPosy2", ",", "curRad2"}], "]"}]}], ",", 
          RowBox[{
           SuperscriptBox["curPosy1", "\[Prime]",
            MultilineFunction->None], "\[Equal]", 
           RowBox[{"ebYFunc", "[", 
            RowBox[{
            "curPosx1", ",", "curPosy1", ",", "curRad1", ",", "curPosx2", ",",
              "curPosy2", ",", "curRad2"}], "]"}]}]}], "]"}], ",", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{"left", " ", "x", " ", "boundary", " ", "spring"}], " ", 
         "*)"}], "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"cl", "\[Equal]", " ", 
            RowBox[{"cell", "[", 
             RowBox[{
             "curCellID", ",", "curPosx", ",", "curPosy", ",", "curRad", ",", 
              "p1"}], "]"}]}], ",", 
           RowBox[{"bx", " ", "\[Equal]", " ", 
            RowBox[{"leftBoundary", "[", "xbound", "]"}]}]}], "}"}], 
         "\[Rule]", " ", 
         RowBox[{"{", 
          RowBox[{"cl", ",", "bx"}], "}"}]}], ",", "\[IndentingNewLine]", 
        RowBox[{"solving", "[", 
         RowBox[{
          SuperscriptBox["curPosx", "\[Prime]",
           MultilineFunction->None], "\[Equal]", " ", 
          RowBox[{"ebBoundaryFunc", "[", 
           RowBox[{"curPosx", ",", "curRad", ",", "1", 
            RowBox[{"(*", "curDir", "*)"}], ",", "xbound"}], "]"}]}], " ", 
         "]"}], ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{"right", " ", "x", " ", "boundary", " ", "spring"}], " ", 
         "*)"}], "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"cl", "\[Equal]", " ", 
            RowBox[{"cell", "[", 
             RowBox[{
             "curCellID", ",", "curPosx", ",", "curPosy", ",", "curRad", ",", 
              "p1"}], "]"}]}], ",", 
           RowBox[{"bx", " ", "\[Equal]", " ", 
            RowBox[{"rightBoundary", "[", "xbound", "]"}]}]}], "}"}], 
         "\[Rule]", " ", 
         RowBox[{"{", 
          RowBox[{"cl", ",", "bx"}], "}"}]}], ",", "\[IndentingNewLine]", 
        RowBox[{"solving", "[", 
         RowBox[{
          SuperscriptBox["curPosx", "\[Prime]",
           MultilineFunction->None], "\[Equal]", " ", 
          RowBox[{"ebBoundaryFunc", "[", 
           RowBox[{"curPosx", ",", "curRad", ",", 
            RowBox[{"-", "1"}], 
            RowBox[{"(*", "curDir", "*)"}], ",", "xbound"}], "]"}]}], "]"}], 
        ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{"bottom", " ", "boundary"}], " ", "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"cl", "\[Equal]", " ", 
            RowBox[{"cell", "[", 
             RowBox[{
             "curCellID", ",", "curPosx", ",", "curPosy", ",", "curRad", ",", 
              "p1"}], "]"}]}], ",", 
           RowBox[{"by", " ", "\[Equal]", " ", 
            RowBox[{"bottomBoundary", "[", "ybound", "]"}]}]}], "}"}], 
         "\[Rule]", " ", 
         RowBox[{"{", 
          RowBox[{"cl", ",", "by"}], "}"}]}], ",", "\[IndentingNewLine]", 
        RowBox[{"solving", "[", 
         RowBox[{
          SuperscriptBox["curPosy", "\[Prime]",
           MultilineFunction->None], "\[Equal]", " ", 
          RowBox[{"ebBoundaryFunc", "[", 
           RowBox[{"curPosy", ",", "curRad", ",", "1", 
            RowBox[{"(*", "curDir", "*)"}], ",", "ybound"}], "]"}]}], "]"}], 
        ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{"cell", " ", "move", " ", "downward"}], "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"cl", "\[Equal]", " ", 
           RowBox[{"cell", "[", 
            RowBox[{
            "curCellID", ",", "curPosx", ",", "curPosy", ",", "curRad", ",", 
             "p1"}], "]"}]}], "}"}], "\[Rule]", " ", 
         RowBox[{"{", "cl", "}"}]}], ",", "\[IndentingNewLine]", 
        RowBox[{"solving", "[", 
         RowBox[{
          SuperscriptBox["curPosy", "\[Prime]",
           MultilineFunction->None], "\[Equal]", " ", 
          RowBox[{"-", "10"}]}], "]"}], ",", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{
          RowBox[{"-", " ", "cell"}], " ", "division"}], "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"cell", "[", 
           RowBox[{
           "curCellID", ",", "curPosx", ",", "curPosy", ",", "curRad", ",", 
            "p1"}], "]"}], "}"}], "\[Rule]", " ", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"cell", "[", 
            RowBox[{
             RowBox[{"grammarCreateObjectID", "[", "1", "]"}], ",", 
             RowBox[{"curPosx", "+", 
              RowBox[{"0.1", "curRad", "*", 
               RowBox[{"Cos", "[", "angleChildCenter", "]"}]}]}], ",", 
             RowBox[{"curPosy", "+", 
              RowBox[{"0.1", "curRad", "*", 
               RowBox[{"Sin", "[", "angleChildCenter", "]"}]}]}], ",", 
             RowBox[{"curRad", "/", 
              SqrtBox["2"]}], ",", "p1"}], "]"}], ",", "\[IndentingNewLine]", 
           RowBox[{"cell", "[", 
            RowBox[{
             RowBox[{"grammarCreateObjectID", "[", "2", "]"}], ",", 
             RowBox[{"curPosx", "-", 
              RowBox[{"0.1", "curRad", "*", 
               RowBox[{"Cos", "[", "angleChildCenter", "]"}]}]}], ",", 
             RowBox[{"curPosy", "-", 
              RowBox[{"0.1", "curRad", "*", 
               RowBox[{"Sin", "[", "angleChildCenter", "]"}]}]}], ",", 
             RowBox[{"curRad", "/", 
              SqrtBox["2"]}], ",", "p1"}], "]"}]}], "\[IndentingNewLine]", 
          "}"}]}], ",", "\[IndentingNewLine]", 
        RowBox[{"with", "[", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"1", "/", "gCellCycleTime"}], ")"}], "*", 
          RowBox[{"grammarPDF", "[", 
           RowBox[{
            RowBox[{"UniformDistribution", "[", 
             RowBox[{"{", 
              RowBox[{"0", ",", 
               RowBox[{"2", "Pi"}]}], "}"}], "]"}], ",", "angleChildCenter"}],
            "]"}], "*", 
          RowBox[{"grammarPDF", "[", 
           RowBox[{
            RowBox[{"UniformDistribution", "[", 
             RowBox[{"{", 
              RowBox[{"0", ",", "1"}], "}"}], "]"}], ",", 
            "randValCellType1"}], "]"}], "*", 
          RowBox[{"grammarPDF", "[", 
           RowBox[{
            RowBox[{"UniformDistribution", "[", 
             RowBox[{"{", 
              RowBox[{"0", ",", "1"}], "}"}], "]"}], ",", 
            "randValCellType2"}], "]"}]}], "]"}], ",", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{"cell", " ", "death"}], "*)"}], "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"cell", "[", 
           RowBox[{
           "curCellID", ",", "curPosx", ",", "curPosy", ",", "curRad", ",", 
            "p1"}], "]"}], "}"}], "\[Rule]", " ", 
         RowBox[{"{", "}"}]}], ",", "\[IndentingNewLine]", 
        RowBox[{"with", "[", 
         RowBox[{"(", 
          RowBox[{"0.1", "/", "gCellCycleTime"}], ")"}], "]"}], ",", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{"continuous", " ", "change", " ", "in", " ", 
          RowBox[{"cell", "'"}], "s", " ", "signal", " ", "concentration", 
          " ", "from", " ", "the", " ", "space", " ", "grid"}], "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"cell", "[", 
           RowBox[{
           "curCellID", ",", "curPosx", ",", "curPosy", ",", "curRad", ",", 
            "p1"}], "]"}], "}"}], "\[Rule]", " ", 
         RowBox[{"{", 
          RowBox[{"cell", "[", 
           RowBox[{
           "curCellID", ",", "curPosx", ",", "curPosy", ",", "curRad", ",", 
            "p1"}], "]"}], "}"}]}], ",", "\[IndentingNewLine]", 
        RowBox[{"solving", "[", 
         RowBox[{"p1", "\[Equal]", 
          RowBox[{"prot1", "[", 
           RowBox[{"curPosx", ",", "curPosy", ",", "curRad"}], "]"}]}], " ", 
         "]"}], ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{"cell", " ", "produces", " ", "protein"}], " ", "-", " ", 
          RowBox[{
          "adding", " ", "to", " ", "the", " ", "source", " ", "function"}]}],
          "*)"}], "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"cell", "[", 
          RowBox[{
          "curCellID", ",", "curPosx", ",", "curPosy", ",", "curRad", ",", 
           "p1"}], "]"}], "\[Rule]", " ", 
         RowBox[{"{", 
          RowBox[{"cell", "[", 
           RowBox[{
           "curCellID", ",", "curPosx", ",", "curPosy", ",", "curRad", ",", 
            "p1"}], "]"}], "}"}]}], ",", "\[IndentingNewLine]", 
        RowBox[{"solving", "[", 
         RowBox[{"src1", "\[Equal]", " ", 
          RowBox[{"cellSourceFunc", "[", 
           RowBox[{"1", ",", "curPosx", ",", "curPosy", ",", "curRad"}], 
           "]"}]}], "]"}]}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
       "}"}]}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", "gCells2DDiffusion"}], "Input",
 CellFrame->{{0, 0}, {0, 0.5}},
 CellGroupingRules->{GroupTogetherGrouping, 10001.},
 CellChangeTimes->{{3.492190498869582*^9, 3.492190520203803*^9}, {
   3.492190721788333*^9, 3.492190746864767*^9}, 3.492197202629016*^9, {
   3.4921973224148664`*^9, 3.4921973252760305`*^9}}]
}, Open  ]],

Cell[BoxData[
 RowBox[{"Grammar", "[", 
  RowBox[{
   RowBox[{"spatialGrammar", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"spatialObject", "\[Rule]", "cell"}], ",", 
      RowBox[{"spatialObjCoordParamters", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"2", ",", "3"}], "}"}]}], ",", 
      RowBox[{"spatialObjRadParam", "\[Rule]", "4"}], ",", 
      RowBox[{"spatialObjDistance", "\[Rule]", "gCellsDistance"}], ",", 
      RowBox[{"spatialBoundaryDistance", "\[Rule]", "gCellPlaneDistance"}], 
      ",", 
      RowBox[{"spatialBottomBoundary", "\[Rule]", "bottomBoundary"}], ",", 
      RowBox[{"spatialLeftBoundary", "\[Rule]", "leftBoundary"}], ",", 
      RowBox[{"spatialRightBoundary", "\[Rule]", "rightBoundary"}]}], "}"}]}],
    ",", 
   RowBox[{"gDiffusion", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"gDiffVariable", "\[Rule]", 
       RowBox[{"{", "prot1", "}"}]}], ",", 
      RowBox[{"gDiffSpatialParamX", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"{", 
         RowBox[{"cell", ",", "2"}], "}"}], "}"}]}], ",", 
      RowBox[{"gDiffSpatialParamY", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"{", 
         RowBox[{"cell", ",", "3"}], "}"}], "}"}]}], ",", 
      RowBox[{"gDiffSpatialParamR", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"{", 
         RowBox[{"cell", ",", "4"}], "}"}], "}"}]}], ",", 
      RowBox[{"gDiffDecay", "\[Rule]", 
       RowBox[{"{", "gProt1Decay", "}"}]}], ",", 
      RowBox[{"gDiffConstant", "\[Rule]", 
       RowBox[{"{", "gProt1Diff", "}"}]}], ",", 
      RowBox[{"gDiffSource", "\[Rule]", 
       RowBox[{"{", "src1", "}"}]}], ",", 
      RowBox[{"gDiffBoundaryTypeLeft", "\[Rule]", "gPDETypeNeumann"}], ",", 
      RowBox[{"gDiffBoundaryTypeRight", "\[Rule]", "gPDETypeNeumann"}], ",", 
      RowBox[{"gDiffBoundaryTypeBottom", "\[Rule]", "gPDETypeDirichlet"}], 
      ",", 
      RowBox[{"gDiffBoundaryTypeTop", "\[Rule]", "gPDETypeNeumann"}], ",", 
      RowBox[{"gDiffBoundaryValLeft", "\[Rule]", "0"}], ",", 
      RowBox[{"gDiffBoundaryValRight", "\[Rule]", "0"}], ",", 
      RowBox[{"gDiffBoundaryValBottom", "\[Rule]", "0"}], ",", 
      RowBox[{"gDiffBoundaryValTop", "\[Rule]", "0"}]}], "}"}]}], ",", 
   RowBox[{"rules", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       RowBox[{"{", 
        RowBox[{"cl", "\[Equal]", 
         RowBox[{"cell", "[", 
          RowBox[{
          "curCellID", ",", "curPosx", ",", "curPosy", ",", "curRad", ",", 
           "p1"}], "]"}]}], "}"}], "\[Rule]", "cl"}], ",", 
      RowBox[{"solving", "[", 
       RowBox[{
        SuperscriptBox["curRad", "\[Prime]",
         MultilineFunction->None], "\[Equal]", 
        RowBox[{"radFunction", "[", "curRad", "]"}]}], "]"}], ",", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"c1", "\[Equal]", 
          RowBox[{"cell", "[", 
           RowBox[{
           "curCellID1", ",", "curPosx1", ",", "curPosy1", ",", "curRad1", 
            ",", "p11"}], "]"}]}], ",", 
         RowBox[{"c2", "\[Equal]", 
          RowBox[{"cell", "[", 
           RowBox[{
           "curCellID2", ",", "curPosx2", ",", "curPosy2", ",", "curRad2", 
            ",", "p12"}], "]"}]}]}], "}"}], "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"c1", ",", "c2"}], "}"}]}], ",", 
      RowBox[{"solving", "[", 
       RowBox[{
        RowBox[{
         SuperscriptBox["curPosx1", "\[Prime]",
          MultilineFunction->None], "\[Equal]", 
         RowBox[{"ebXFunc", "[", 
          RowBox[{
          "curPosx1", ",", "curPosy1", ",", "curRad1", ",", "curPosx2", ",", 
           "curPosy2", ",", "curRad2"}], "]"}]}], ",", 
        RowBox[{
         SuperscriptBox["curPosy1", "\[Prime]",
          MultilineFunction->None], "\[Equal]", 
         RowBox[{"ebYFunc", "[", 
          RowBox[{
          "curPosx1", ",", "curPosy1", ",", "curRad1", ",", "curPosx2", ",", 
           "curPosy2", ",", "curRad2"}], "]"}]}]}], "]"}], ",", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"cl", "\[Equal]", 
          RowBox[{"cell", "[", 
           RowBox[{
           "curCellID", ",", "curPosx", ",", "curPosy", ",", "curRad", ",", 
            "p1"}], "]"}]}], ",", 
         RowBox[{"bx", "\[Equal]", 
          RowBox[{"leftBoundary", "[", "xbound", "]"}]}]}], "}"}], "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"cl", ",", "bx"}], "}"}]}], ",", 
      RowBox[{"solving", "[", 
       RowBox[{
        SuperscriptBox["curPosx", "\[Prime]",
         MultilineFunction->None], "\[Equal]", 
        RowBox[{"ebBoundaryFunc", "[", 
         RowBox[{"curPosx", ",", "curRad", ",", "1", ",", "xbound"}], "]"}]}],
        "]"}], ",", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"cl", "\[Equal]", 
          RowBox[{"cell", "[", 
           RowBox[{
           "curCellID", ",", "curPosx", ",", "curPosy", ",", "curRad", ",", 
            "p1"}], "]"}]}], ",", 
         RowBox[{"bx", "\[Equal]", 
          RowBox[{"rightBoundary", "[", "xbound", "]"}]}]}], "}"}], "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"cl", ",", "bx"}], "}"}]}], ",", 
      RowBox[{"solving", "[", 
       RowBox[{
        SuperscriptBox["curPosx", "\[Prime]",
         MultilineFunction->None], "\[Equal]", 
        RowBox[{"ebBoundaryFunc", "[", 
         RowBox[{"curPosx", ",", "curRad", ",", 
          RowBox[{"-", "1"}], ",", "xbound"}], "]"}]}], "]"}], ",", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"cl", "\[Equal]", 
          RowBox[{"cell", "[", 
           RowBox[{
           "curCellID", ",", "curPosx", ",", "curPosy", ",", "curRad", ",", 
            "p1"}], "]"}]}], ",", 
         RowBox[{"by", "\[Equal]", 
          RowBox[{"bottomBoundary", "[", "ybound", "]"}]}]}], "}"}], 
       "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"cl", ",", "by"}], "}"}]}], ",", 
      RowBox[{"solving", "[", 
       RowBox[{
        SuperscriptBox["curPosy", "\[Prime]",
         MultilineFunction->None], "\[Equal]", 
        RowBox[{"ebBoundaryFunc", "[", 
         RowBox[{"curPosy", ",", "curRad", ",", "1", ",", "ybound"}], "]"}]}],
        "]"}], ",", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"cl", "\[Equal]", 
         RowBox[{"cell", "[", 
          RowBox[{
          "curCellID", ",", "curPosx", ",", "curPosy", ",", "curRad", ",", 
           "p1"}], "]"}]}], "}"}], "\[Rule]", 
       RowBox[{"{", "cl", "}"}]}], ",", 
      RowBox[{"solving", "[", 
       RowBox[{
        SuperscriptBox["curPosy", "\[Prime]",
         MultilineFunction->None], "\[Equal]", 
        RowBox[{"-", "10"}]}], "]"}], ",", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"cell", "[", 
         RowBox[{
         "curCellID", ",", "curPosx", ",", "curPosy", ",", "curRad", ",", 
          "p1"}], "]"}], "}"}], "\[Rule]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"cell", "[", 
          RowBox[{
           RowBox[{"grammarCreateObjectID", "[", "1", "]"}], ",", 
           RowBox[{"curPosx", "+", 
            RowBox[{"0.1`", " ", "curRad", " ", 
             RowBox[{"Cos", "[", "angleChildCenter", "]"}]}]}], ",", 
           RowBox[{"curPosy", "+", 
            RowBox[{"0.1`", " ", "curRad", " ", 
             RowBox[{"Sin", "[", "angleChildCenter", "]"}]}]}], ",", 
           FractionBox["curRad", 
            SqrtBox["2"]], ",", "p1"}], "]"}], ",", 
         RowBox[{"cell", "[", 
          RowBox[{
           RowBox[{"grammarCreateObjectID", "[", "2", "]"}], ",", 
           RowBox[{"curPosx", "-", 
            RowBox[{"0.1`", " ", "curRad", " ", 
             RowBox[{"Cos", "[", "angleChildCenter", "]"}]}]}], ",", 
           RowBox[{"curPosy", "-", 
            RowBox[{"0.1`", " ", "curRad", " ", 
             RowBox[{"Sin", "[", "angleChildCenter", "]"}]}]}], ",", 
           FractionBox["curRad", 
            SqrtBox["2"]], ",", "p1"}], "]"}]}], "}"}]}], ",", 
      RowBox[{"with", "[", 
       RowBox[{
        FractionBox["1", "gCellCycleTime"], 
        RowBox[{
         RowBox[{"grammarPDF", "[", 
          RowBox[{
           RowBox[{"UniformDistribution", "[", 
            RowBox[{"{", 
             RowBox[{"0", ",", "1"}], "}"}], "]"}], ",", "randValCellType1"}],
           "]"}], " ", 
         RowBox[{"grammarPDF", "[", 
          RowBox[{
           RowBox[{"UniformDistribution", "[", 
            RowBox[{"{", 
             RowBox[{"0", ",", "1"}], "}"}], "]"}], ",", "randValCellType2"}],
           "]"}], " ", 
         RowBox[{"grammarPDF", "[", 
          RowBox[{
           RowBox[{"UniformDistribution", "[", 
            RowBox[{"{", 
             RowBox[{"0", ",", 
              RowBox[{"2", " ", "\[Pi]"}]}], "}"}], "]"}], ",", 
           "angleChildCenter"}], "]"}]}]}], "]"}], ",", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"cell", "[", 
         RowBox[{
         "curCellID", ",", "curPosx", ",", "curPosy", ",", "curRad", ",", 
          "p1"}], "]"}], "}"}], "\[Rule]", 
       RowBox[{"{", "}"}]}], ",", 
      RowBox[{"with", "[", 
       FractionBox["0.1`", "gCellCycleTime"], "]"}], ",", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"cell", "[", 
         RowBox[{
         "curCellID", ",", "curPosx", ",", "curPosy", ",", "curRad", ",", 
          "p1"}], "]"}], "}"}], "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"cell", "[", 
         RowBox[{
         "curCellID", ",", "curPosx", ",", "curPosy", ",", "curRad", ",", 
          "p1"}], "]"}], "}"}]}], ",", 
      RowBox[{"solving", "[", 
       RowBox[{"p1", "\[Equal]", 
        RowBox[{"prot1", "[", 
         RowBox[{"curPosx", ",", "curPosy", ",", "curRad"}], "]"}]}], "]"}], 
      ",", 
      RowBox[{
       RowBox[{"cell", "[", 
        RowBox[{
        "curCellID", ",", "curPosx", ",", "curPosy", ",", "curRad", ",", 
         "p1"}], "]"}], "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"cell", "[", 
         RowBox[{
         "curCellID", ",", "curPosx", ",", "curPosy", ",", "curRad", ",", 
          "p1"}], "]"}], "}"}]}], ",", 
      RowBox[{"solving", "[", 
       RowBox[{"src1", "\[Equal]", 
        RowBox[{"cellSourceFunc", "[", 
         RowBox[{"1", ",", "curPosx", ",", "curPosy", ",", "curRad"}], 
         "]"}]}], "]"}]}], "}"}]}]}], "]"}]], "Output",
 CellChangeTimes->{3.4921973256680527`*^9, 3.4921980586539774`*^9}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"cells2DDiffusionCambium", " ", "=", " ", 
  RowBox[{"gCells2DDiffusion", " ", "//.", " ", "TranslateP2C"}]}]], "Input",
 CellFrame->{{0, 0}, {0, 0.5}},
 CellChangeTimes->{{3.4921912388399067`*^9, 3.4921912641263523`*^9}}],

Cell[BoxData[
 RowBox[{"CambiumArrow", "[", 
  RowBox[{
   RowBox[{"DynGram", "[", "composite", "]"}], ",", 
   RowBox[{"{", "}"}], ",", 
   RowBox[{"{", "}"}], ",", 
   RowBox[{"{", "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"GrammarParameters", "[", 
      RowBox[{
       RowBox[{"spatialGrammar", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"spatialObject", "\[Rule]", "cell"}], ",", 
          RowBox[{"spatialObjCoordParamters", "\[Rule]", 
           RowBox[{"{", 
            RowBox[{"2", ",", "3"}], "}"}]}], ",", 
          RowBox[{"spatialObjRadParam", "\[Rule]", "4"}], ",", 
          RowBox[{"spatialObjDistance", "\[Rule]", "gCellsDistance"}], ",", 
          RowBox[{
          "spatialBoundaryDistance", "\[Rule]", "gCellPlaneDistance"}], ",", 
          RowBox[{"spatialBottomBoundary", "\[Rule]", "bottomBoundary"}], ",", 
          RowBox[{"spatialLeftBoundary", "\[Rule]", "leftBoundary"}], ",", 
          RowBox[{"spatialRightBoundary", "\[Rule]", "rightBoundary"}]}], 
         "}"}]}], ",", 
       RowBox[{"gDiffusion", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"gDiffVariable", "\[Rule]", 
           RowBox[{"{", "prot1", "}"}]}], ",", 
          RowBox[{"gDiffSpatialParamX", "\[Rule]", 
           RowBox[{"{", 
            RowBox[{"{", 
             RowBox[{"cell", ",", "2"}], "}"}], "}"}]}], ",", 
          RowBox[{"gDiffSpatialParamY", "\[Rule]", 
           RowBox[{"{", 
            RowBox[{"{", 
             RowBox[{"cell", ",", "3"}], "}"}], "}"}]}], ",", 
          RowBox[{"gDiffSpatialParamR", "\[Rule]", 
           RowBox[{"{", 
            RowBox[{"{", 
             RowBox[{"cell", ",", "4"}], "}"}], "}"}]}], ",", 
          RowBox[{"gDiffDecay", "\[Rule]", 
           RowBox[{"{", "gProt1Decay", "}"}]}], ",", 
          RowBox[{"gDiffConstant", "\[Rule]", 
           RowBox[{"{", "gProt1Diff", "}"}]}], ",", 
          RowBox[{"gDiffSource", "\[Rule]", 
           RowBox[{"{", "src1", "}"}]}], ",", 
          RowBox[{"gDiffBoundaryTypeLeft", "\[Rule]", "gPDETypeNeumann"}], 
          ",", 
          RowBox[{"gDiffBoundaryTypeRight", "\[Rule]", "gPDETypeNeumann"}], 
          ",", 
          RowBox[{"gDiffBoundaryTypeBottom", "\[Rule]", "gPDETypeDirichlet"}],
           ",", 
          RowBox[{"gDiffBoundaryTypeTop", "\[Rule]", "gPDETypeNeumann"}], ",", 
          RowBox[{"gDiffBoundaryValLeft", "\[Rule]", "0"}], ",", 
          RowBox[{"gDiffBoundaryValRight", "\[Rule]", "0"}], ",", 
          RowBox[{"gDiffBoundaryValBottom", "\[Rule]", "0"}], ",", 
          RowBox[{"gDiffBoundaryValTop", "\[Rule]", "0"}]}], "}"}]}]}], "]"}],
      ",", 
     RowBox[{"Rules", "[", 
      RowBox[{
       RowBox[{"CambiumArrow", "[", 
        RowBox[{
         RowBox[{"DynGram", "[", 
          RowBox[{"continuous", ",", "rule"}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"cl", "\[Equal]", 
           RowBox[{"cell", "[", 
            RowBox[{
            "curCellID", ",", "curPosx", ",", "curPosy", ",", "curRad", ",", 
             "p1"}], "]"}]}], "}"}], ",", 
         RowBox[{"{", "}"}], ",", 
         RowBox[{"{", "cl", "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"solving", "[", 
           RowBox[{
            SuperscriptBox["curRad", "\[Prime]",
             MultilineFunction->None], "\[Equal]", 
            RowBox[{"radFunction", "[", "curRad", "]"}]}], "]"}], "}"}]}], 
        "]"}], ",", 
       RowBox[{"CambiumArrow", "[", 
        RowBox[{
         RowBox[{"DynGram", "[", 
          RowBox[{"continuous", ",", "rule"}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"c1", "\[Equal]", 
            RowBox[{"cell", "[", 
             RowBox[{
             "curCellID1", ",", "curPosx1", ",", "curPosy1", ",", "curRad1", 
              ",", "p11"}], "]"}]}], ",", 
           RowBox[{"c2", "\[Equal]", 
            RowBox[{"cell", "[", 
             RowBox[{
             "curCellID2", ",", "curPosx2", ",", "curPosy2", ",", "curRad2", 
              ",", "p12"}], "]"}]}]}], "}"}], ",", 
         RowBox[{"{", "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"c1", ",", "c2"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"solving", "[", 
           RowBox[{
            RowBox[{
             SuperscriptBox["curPosx1", "\[Prime]",
              MultilineFunction->None], "\[Equal]", 
             RowBox[{"ebXFunc", "[", 
              RowBox[{
              "curPosx1", ",", "curPosy1", ",", "curRad1", ",", "curPosx2", 
               ",", "curPosy2", ",", "curRad2"}], "]"}]}], ",", 
            RowBox[{
             SuperscriptBox["curPosy1", "\[Prime]",
              MultilineFunction->None], "\[Equal]", 
             RowBox[{"ebYFunc", "[", 
              RowBox[{
              "curPosx1", ",", "curPosy1", ",", "curRad1", ",", "curPosx2", 
               ",", "curPosy2", ",", "curRad2"}], "]"}]}]}], "]"}], "}"}]}], 
        "]"}], ",", 
       RowBox[{"CambiumArrow", "[", 
        RowBox[{
         RowBox[{"DynGram", "[", 
          RowBox[{"continuous", ",", "rule"}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"cl", "\[Equal]", 
            RowBox[{"cell", "[", 
             RowBox[{
             "curCellID", ",", "curPosx", ",", "curPosy", ",", "curRad", ",", 
              "p1"}], "]"}]}], ",", 
           RowBox[{"bx", "\[Equal]", 
            RowBox[{"leftBoundary", "[", "xbound", "]"}]}]}], "}"}], ",", 
         RowBox[{"{", "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"cl", ",", "bx"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"solving", "[", 
           RowBox[{
            SuperscriptBox["curPosx", "\[Prime]",
             MultilineFunction->None], "\[Equal]", 
            RowBox[{"ebBoundaryFunc", "[", 
             RowBox[{"curPosx", ",", "curRad", ",", "1", ",", "xbound"}], 
             "]"}]}], "]"}], "}"}]}], "]"}], ",", 
       RowBox[{"CambiumArrow", "[", 
        RowBox[{
         RowBox[{"DynGram", "[", 
          RowBox[{"continuous", ",", "rule"}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"cl", "\[Equal]", 
            RowBox[{"cell", "[", 
             RowBox[{
             "curCellID", ",", "curPosx", ",", "curPosy", ",", "curRad", ",", 
              "p1"}], "]"}]}], ",", 
           RowBox[{"bx", "\[Equal]", 
            RowBox[{"rightBoundary", "[", "xbound", "]"}]}]}], "}"}], ",", 
         RowBox[{"{", "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"cl", ",", "bx"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"solving", "[", 
           RowBox[{
            SuperscriptBox["curPosx", "\[Prime]",
             MultilineFunction->None], "\[Equal]", 
            RowBox[{"ebBoundaryFunc", "[", 
             RowBox[{"curPosx", ",", "curRad", ",", 
              RowBox[{"-", "1"}], ",", "xbound"}], "]"}]}], "]"}], "}"}]}], 
        "]"}], ",", 
       RowBox[{"CambiumArrow", "[", 
        RowBox[{
         RowBox[{"DynGram", "[", 
          RowBox[{"continuous", ",", "rule"}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"cl", "\[Equal]", 
            RowBox[{"cell", "[", 
             RowBox[{
             "curCellID", ",", "curPosx", ",", "curPosy", ",", "curRad", ",", 
              "p1"}], "]"}]}], ",", 
           RowBox[{"by", "\[Equal]", 
            RowBox[{"bottomBoundary", "[", "ybound", "]"}]}]}], "}"}], ",", 
         RowBox[{"{", "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"cl", ",", "by"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"solving", "[", 
           RowBox[{
            SuperscriptBox["curPosy", "\[Prime]",
             MultilineFunction->None], "\[Equal]", 
            RowBox[{"ebBoundaryFunc", "[", 
             RowBox[{"curPosy", ",", "curRad", ",", "1", ",", "ybound"}], 
             "]"}]}], "]"}], "}"}]}], "]"}], ",", 
       RowBox[{"CambiumArrow", "[", 
        RowBox[{
         RowBox[{"DynGram", "[", 
          RowBox[{"continuous", ",", "rule"}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"cl", "\[Equal]", 
           RowBox[{"cell", "[", 
            RowBox[{
            "curCellID", ",", "curPosx", ",", "curPosy", ",", "curRad", ",", 
             "p1"}], "]"}]}], "}"}], ",", 
         RowBox[{"{", "}"}], ",", 
         RowBox[{"{", "cl", "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"solving", "[", 
           RowBox[{
            SuperscriptBox["curPosy", "\[Prime]",
             MultilineFunction->None], "\[Equal]", 
            RowBox[{"-", "10"}]}], "]"}], "}"}]}], "]"}], ",", 
       RowBox[{"CambiumArrow", "[", 
        RowBox[{
         RowBox[{"DynGram", "[", 
          RowBox[{"discrete", ",", "rule"}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"cell", "[", 
           RowBox[{
           "curCellID", ",", "curPosx", ",", "curPosy", ",", "curRad", ",", 
            "p1"}], "]"}], "}"}], ",", 
         RowBox[{"{", "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"cell", "[", 
            RowBox[{
             RowBox[{"grammarCreateObjectID", "[", "1", "]"}], ",", 
             RowBox[{"curPosx", "+", 
              RowBox[{"0.1`", " ", "curRad", " ", 
               RowBox[{"Cos", "[", "angleChildCenter", "]"}]}]}], ",", 
             RowBox[{"curPosy", "+", 
              RowBox[{"0.1`", " ", "curRad", " ", 
               RowBox[{"Sin", "[", "angleChildCenter", "]"}]}]}], ",", 
             FractionBox["curRad", 
              SqrtBox["2"]], ",", "p1"}], "]"}], ",", 
           RowBox[{"cell", "[", 
            RowBox[{
             RowBox[{"grammarCreateObjectID", "[", "2", "]"}], ",", 
             RowBox[{"curPosx", "-", 
              RowBox[{"0.1`", " ", "curRad", " ", 
               RowBox[{"Cos", "[", "angleChildCenter", "]"}]}]}], ",", 
             RowBox[{"curPosy", "-", 
              RowBox[{"0.1`", " ", "curRad", " ", 
               RowBox[{"Sin", "[", "angleChildCenter", "]"}]}]}], ",", 
             FractionBox["curRad", 
              SqrtBox["2"]], ",", "p1"}], "]"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"with", "[", 
           RowBox[{
            FractionBox["1", "gCellCycleTime"], 
            RowBox[{
             RowBox[{"grammarPDF", "[", 
              RowBox[{
               RowBox[{"UniformDistribution", "[", 
                RowBox[{"{", 
                 RowBox[{"0", ",", "1"}], "}"}], "]"}], ",", 
               "randValCellType1"}], "]"}], " ", 
             RowBox[{"grammarPDF", "[", 
              RowBox[{
               RowBox[{"UniformDistribution", "[", 
                RowBox[{"{", 
                 RowBox[{"0", ",", "1"}], "}"}], "]"}], ",", 
               "randValCellType2"}], "]"}], " ", 
             RowBox[{"grammarPDF", "[", 
              RowBox[{
               RowBox[{"UniformDistribution", "[", 
                RowBox[{"{", 
                 RowBox[{"0", ",", 
                  RowBox[{"2", " ", "\[Pi]"}]}], "}"}], "]"}], ",", 
               "angleChildCenter"}], "]"}]}]}], "]"}], "}"}]}], "]"}], ",", 
       RowBox[{"CambiumArrow", "[", 
        RowBox[{
         RowBox[{"DynGram", "[", 
          RowBox[{"discrete", ",", "rule"}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"cell", "[", 
           RowBox[{
           "curCellID", ",", "curPosx", ",", "curPosy", ",", "curRad", ",", 
            "p1"}], "]"}], "}"}], ",", 
         RowBox[{"{", "}"}], ",", 
         RowBox[{"{", "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"with", "[", 
           FractionBox["0.1`", "gCellCycleTime"], "]"}], "}"}]}], "]"}], ",", 
       RowBox[{"CambiumArrow", "[", 
        RowBox[{
         RowBox[{"DynGram", "[", 
          RowBox[{"continuous", ",", "rule"}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"cell", "[", 
           RowBox[{
           "curCellID", ",", "curPosx", ",", "curPosy", ",", "curRad", ",", 
            "p1"}], "]"}], "}"}], ",", 
         RowBox[{"{", "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"cell", "[", 
           RowBox[{
           "curCellID", ",", "curPosx", ",", "curPosy", ",", "curRad", ",", 
            "p1"}], "]"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"solving", "[", 
           RowBox[{"p1", "\[Equal]", 
            RowBox[{"prot1", "[", 
             RowBox[{"curPosx", ",", "curPosy", ",", "curRad"}], "]"}]}], 
           "]"}], "}"}]}], "]"}], ",", 
       RowBox[{"CambiumArrow", "[", 
        RowBox[{
         RowBox[{"DynGram", "[", 
          RowBox[{"continuous", ",", "rule"}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"cell", "[", 
           RowBox[{
           "curCellID", ",", "curPosx", ",", "curPosy", ",", "curRad", ",", 
            "p1"}], "]"}], "}"}], ",", 
         RowBox[{"{", "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"cell", "[", 
           RowBox[{
           "curCellID", ",", "curPosx", ",", "curPosy", ",", "curRad", ",", 
            "p1"}], "]"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"solving", "[", 
           RowBox[{"src1", "\[Equal]", 
            RowBox[{"cellSourceFunc", "[", 
             RowBox[{"1", ",", "curPosx", ",", "curPosy", ",", "curRad"}], 
             "]"}]}], "]"}], "}"}]}], "]"}]}], "]"}]}], "}"}]}], 
  "]"}]], "Output",
 CellChangeTimes->{3.4921912467453585`*^9, 3.4921912798442516`*^9, 
  3.4921972060402107`*^9, 3.492198058680979*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"cells2DDiffusionCambium", " ", "//.", " ", 
  "TranslateC2P"}]], "Input",
 CellFrame->{{0, 0}, {0, 0.5}},
 CellChangeTimes->{{3.4921912724308276`*^9, 3.492191275678013*^9}}],

Cell[BoxData[
 RowBox[{"Grammar", "[", 
  RowBox[{
   RowBox[{"spatialGrammar", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"spatialObject", "\[Rule]", "cell"}], ",", 
      RowBox[{"spatialObjCoordParamters", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"2", ",", "3"}], "}"}]}], ",", 
      RowBox[{"spatialObjRadParam", "\[Rule]", "4"}], ",", 
      RowBox[{"spatialObjDistance", "\[Rule]", "gCellsDistance"}], ",", 
      RowBox[{"spatialBoundaryDistance", "\[Rule]", "gCellPlaneDistance"}], 
      ",", 
      RowBox[{"spatialBottomBoundary", "\[Rule]", "bottomBoundary"}], ",", 
      RowBox[{"spatialLeftBoundary", "\[Rule]", "leftBoundary"}], ",", 
      RowBox[{"spatialRightBoundary", "\[Rule]", "rightBoundary"}]}], "}"}]}],
    ",", 
   RowBox[{"gDiffusion", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"gDiffVariable", "\[Rule]", 
       RowBox[{"{", "prot1", "}"}]}], ",", 
      RowBox[{"gDiffSpatialParamX", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"{", 
         RowBox[{"cell", ",", "2"}], "}"}], "}"}]}], ",", 
      RowBox[{"gDiffSpatialParamY", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"{", 
         RowBox[{"cell", ",", "3"}], "}"}], "}"}]}], ",", 
      RowBox[{"gDiffSpatialParamR", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"{", 
         RowBox[{"cell", ",", "4"}], "}"}], "}"}]}], ",", 
      RowBox[{"gDiffDecay", "\[Rule]", 
       RowBox[{"{", "gProt1Decay", "}"}]}], ",", 
      RowBox[{"gDiffConstant", "\[Rule]", 
       RowBox[{"{", "gProt1Diff", "}"}]}], ",", 
      RowBox[{"gDiffSource", "\[Rule]", 
       RowBox[{"{", "src1", "}"}]}], ",", 
      RowBox[{"gDiffBoundaryTypeLeft", "\[Rule]", "gPDETypeNeumann"}], ",", 
      RowBox[{"gDiffBoundaryTypeRight", "\[Rule]", "gPDETypeNeumann"}], ",", 
      RowBox[{"gDiffBoundaryTypeBottom", "\[Rule]", "gPDETypeDirichlet"}], 
      ",", 
      RowBox[{"gDiffBoundaryTypeTop", "\[Rule]", "gPDETypeNeumann"}], ",", 
      RowBox[{"gDiffBoundaryValLeft", "\[Rule]", "0"}], ",", 
      RowBox[{"gDiffBoundaryValRight", "\[Rule]", "0"}], ",", 
      RowBox[{"gDiffBoundaryValBottom", "\[Rule]", "0"}], ",", 
      RowBox[{"gDiffBoundaryValTop", "\[Rule]", "0"}]}], "}"}]}], ",", 
   RowBox[{"rules", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       RowBox[{"cl", "\[Equal]", 
        RowBox[{"cell", "[", 
         RowBox[{
         "curCellID", ",", "curPosx", ",", "curPosy", ",", "curRad", ",", 
          "p1"}], "]"}]}], "\[Rule]", "cl"}], ",", 
      RowBox[{"solving", "[", 
       RowBox[{
        SuperscriptBox["curRad", "\[Prime]",
         MultilineFunction->None], "\[Equal]", 
        RowBox[{"radFunction", "[", "curRad", "]"}]}], "]"}], ",", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"c1", "\[Equal]", 
          RowBox[{"cell", "[", 
           RowBox[{
           "curCellID1", ",", "curPosx1", ",", "curPosy1", ",", "curRad1", 
            ",", "p11"}], "]"}]}], ",", 
         RowBox[{"c2", "\[Equal]", 
          RowBox[{"cell", "[", 
           RowBox[{
           "curCellID2", ",", "curPosx2", ",", "curPosy2", ",", "curRad2", 
            ",", "p12"}], "]"}]}]}], "}"}], "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"c1", ",", "c2"}], "}"}]}], ",", 
      RowBox[{"solving", "[", 
       RowBox[{
        RowBox[{
         SuperscriptBox["curPosx1", "\[Prime]",
          MultilineFunction->None], "\[Equal]", 
         RowBox[{"ebXFunc", "[", 
          RowBox[{
          "curPosx1", ",", "curPosy1", ",", "curRad1", ",", "curPosx2", ",", 
           "curPosy2", ",", "curRad2"}], "]"}]}], ",", 
        RowBox[{
         SuperscriptBox["curPosy1", "\[Prime]",
          MultilineFunction->None], "\[Equal]", 
         RowBox[{"ebYFunc", "[", 
          RowBox[{
          "curPosx1", ",", "curPosy1", ",", "curRad1", ",", "curPosx2", ",", 
           "curPosy2", ",", "curRad2"}], "]"}]}]}], "]"}], ",", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"cl", "\[Equal]", 
          RowBox[{"cell", "[", 
           RowBox[{
           "curCellID", ",", "curPosx", ",", "curPosy", ",", "curRad", ",", 
            "p1"}], "]"}]}], ",", 
         RowBox[{"bx", "\[Equal]", 
          RowBox[{"leftBoundary", "[", "xbound", "]"}]}]}], "}"}], "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"cl", ",", "bx"}], "}"}]}], ",", 
      RowBox[{"solving", "[", 
       RowBox[{
        SuperscriptBox["curPosx", "\[Prime]",
         MultilineFunction->None], "\[Equal]", 
        RowBox[{"ebBoundaryFunc", "[", 
         RowBox[{"curPosx", ",", "curRad", ",", "1", ",", "xbound"}], "]"}]}],
        "]"}], ",", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"cl", "\[Equal]", 
          RowBox[{"cell", "[", 
           RowBox[{
           "curCellID", ",", "curPosx", ",", "curPosy", ",", "curRad", ",", 
            "p1"}], "]"}]}], ",", 
         RowBox[{"bx", "\[Equal]", 
          RowBox[{"rightBoundary", "[", "xbound", "]"}]}]}], "}"}], "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"cl", ",", "bx"}], "}"}]}], ",", 
      RowBox[{"solving", "[", 
       RowBox[{
        SuperscriptBox["curPosx", "\[Prime]",
         MultilineFunction->None], "\[Equal]", 
        RowBox[{"ebBoundaryFunc", "[", 
         RowBox[{"curPosx", ",", "curRad", ",", 
          RowBox[{"-", "1"}], ",", "xbound"}], "]"}]}], "]"}], ",", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"cl", "\[Equal]", 
          RowBox[{"cell", "[", 
           RowBox[{
           "curCellID", ",", "curPosx", ",", "curPosy", ",", "curRad", ",", 
            "p1"}], "]"}]}], ",", 
         RowBox[{"by", "\[Equal]", 
          RowBox[{"bottomBoundary", "[", "ybound", "]"}]}]}], "}"}], 
       "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"cl", ",", "by"}], "}"}]}], ",", 
      RowBox[{"solving", "[", 
       RowBox[{
        SuperscriptBox["curPosy", "\[Prime]",
         MultilineFunction->None], "\[Equal]", 
        RowBox[{"ebBoundaryFunc", "[", 
         RowBox[{"curPosy", ",", "curRad", ",", "1", ",", "ybound"}], "]"}]}],
        "]"}], ",", 
      RowBox[{
       RowBox[{"cl", "\[Equal]", 
        RowBox[{"cell", "[", 
         RowBox[{
         "curCellID", ",", "curPosx", ",", "curPosy", ",", "curRad", ",", 
          "p1"}], "]"}]}], "\[Rule]", "cl"}], ",", 
      RowBox[{"solving", "[", 
       RowBox[{
        SuperscriptBox["curPosy", "\[Prime]",
         MultilineFunction->None], "\[Equal]", 
        RowBox[{"-", "10"}]}], "]"}], ",", 
      RowBox[{
       RowBox[{"cell", "[", 
        RowBox[{
        "curCellID", ",", "curPosx", ",", "curPosy", ",", "curRad", ",", 
         "p1"}], "]"}], "\[Rule]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"cell", "[", 
          RowBox[{
           RowBox[{"grammarCreateObjectID", "[", "1", "]"}], ",", 
           RowBox[{"curPosx", "+", 
            RowBox[{"0.1`", " ", "curRad", " ", 
             RowBox[{"Cos", "[", "angleChildCenter", "]"}]}]}], ",", 
           RowBox[{"curPosy", "+", 
            RowBox[{"0.1`", " ", "curRad", " ", 
             RowBox[{"Sin", "[", "angleChildCenter", "]"}]}]}], ",", 
           FractionBox["curRad", 
            SqrtBox["2"]], ",", "p1"}], "]"}], ",", 
         RowBox[{"cell", "[", 
          RowBox[{
           RowBox[{"grammarCreateObjectID", "[", "2", "]"}], ",", 
           RowBox[{"curPosx", "-", 
            RowBox[{"0.1`", " ", "curRad", " ", 
             RowBox[{"Cos", "[", "angleChildCenter", "]"}]}]}], ",", 
           RowBox[{"curPosy", "-", 
            RowBox[{"0.1`", " ", "curRad", " ", 
             RowBox[{"Sin", "[", "angleChildCenter", "]"}]}]}], ",", 
           FractionBox["curRad", 
            SqrtBox["2"]], ",", "p1"}], "]"}]}], "}"}]}], ",", 
      RowBox[{"with", "[", 
       RowBox[{
        FractionBox["1", "gCellCycleTime"], 
        RowBox[{
         RowBox[{"grammarPDF", "[", 
          RowBox[{
           RowBox[{"UniformDistribution", "[", 
            RowBox[{"{", 
             RowBox[{"0", ",", "1"}], "}"}], "]"}], ",", "randValCellType1"}],
           "]"}], " ", 
         RowBox[{"grammarPDF", "[", 
          RowBox[{
           RowBox[{"UniformDistribution", "[", 
            RowBox[{"{", 
             RowBox[{"0", ",", "1"}], "}"}], "]"}], ",", "randValCellType2"}],
           "]"}], " ", 
         RowBox[{"grammarPDF", "[", 
          RowBox[{
           RowBox[{"UniformDistribution", "[", 
            RowBox[{"{", 
             RowBox[{"0", ",", 
              RowBox[{"2", " ", "\[Pi]"}]}], "}"}], "]"}], ",", 
           "angleChildCenter"}], "]"}]}]}], "]"}], ",", 
      RowBox[{
       RowBox[{"cell", "[", 
        RowBox[{
        "curCellID", ",", "curPosx", ",", "curPosy", ",", "curRad", ",", 
         "p1"}], "]"}], "\[Rule]", 
       RowBox[{"{", "}"}]}], ",", 
      RowBox[{"with", "[", 
       FractionBox["0.1`", "gCellCycleTime"], "]"}], ",", 
      RowBox[{
       RowBox[{"cell", "[", 
        RowBox[{
        "curCellID", ",", "curPosx", ",", "curPosy", ",", "curRad", ",", 
         "p1"}], "]"}], "\[Rule]", 
       RowBox[{"cell", "[", 
        RowBox[{
        "curCellID", ",", "curPosx", ",", "curPosy", ",", "curRad", ",", 
         "p1"}], "]"}]}], ",", 
      RowBox[{"solving", "[", 
       RowBox[{"p1", "\[Equal]", 
        RowBox[{"prot1", "[", 
         RowBox[{"curPosx", ",", "curPosy", ",", "curRad"}], "]"}]}], "]"}], 
      ",", 
      RowBox[{
       RowBox[{"cell", "[", 
        RowBox[{
        "curCellID", ",", "curPosx", ",", "curPosy", ",", "curRad", ",", 
         "p1"}], "]"}], "\[Rule]", 
       RowBox[{"cell", "[", 
        RowBox[{
        "curCellID", ",", "curPosx", ",", "curPosy", ",", "curRad", ",", 
         "p1"}], "]"}]}], ",", 
      RowBox[{"solving", "[", 
       RowBox[{"src1", "\[Equal]", 
        RowBox[{"cellSourceFunc", "[", 
         RowBox[{"1", ",", "curPosx", ",", "curPosy", ",", "curRad"}], 
         "]"}]}], "]"}]}], "}"}]}]}], "]"}]], "Output",
 CellChangeTimes->{3.4921912822673903`*^9, 3.492197206076213*^9, 
  3.49219805870298*^9}]
}, Open  ]]
},
WindowSize->{990, 626},
WindowMargins->{{-21, Automatic}, {Automatic, -5}},
FrontEndVersion->"7.0 for Microsoft Windows (64-bit) (November 10, 2008)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[545, 20, 881, 13, 84, "Text"],
Cell[1429, 35, 304, 7, 31, "Input"],
Cell[CellGroupData[{
Cell[1758, 46, 423, 8, 61, "Text",
 CellGroupingRules->{GroupTogetherGrouping, 10001.}],
Cell[2184, 56, 1824, 44, 240, "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10001.}],
Cell[4011, 102, 1357, 38, 70, "Output",
 CellGroupingRules->{GroupTogetherGrouping, 10001.}]
}, Open  ]],
Cell[CellGroupData[{
Cell[5405, 145, 362, 6, 39, "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10000.}],
Cell[5770, 153, 2508, 66, 140, "Output",
 CellGroupingRules->{GroupTogetherGrouping, 10000.}],
Cell[8281, 221, 266, 5, 39, "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10000.}],
Cell[8550, 228, 1373, 37, 70, "Output",
 CellGroupingRules->{GroupTogetherGrouping, 10000.}]
}, Open  ]],
Cell[CellGroupData[{
Cell[9960, 270, 552, 9, 81, "Text",
 CellGroupingRules->{GroupTogetherGrouping, 10001.}],
Cell[10515, 281, 15119, 344, 1518, "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10001.}]
}, Open  ]],
Cell[25649, 628, 10302, 260, 659, "Output"],
Cell[CellGroupData[{
Cell[35976, 892, 245, 4, 39, "Input"],
Cell[36224, 898, 13429, 326, 747, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[49690, 1229, 197, 4, 39, "Input"],
Cell[49890, 1235, 10070, 253, 659, "Output"]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
